package pmm.antiaircraft1;

import android.content.Context;
import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.os.Handler;
import android.util.DisplayMetrics;
import android.view.SurfaceHolder;

public class GameThread extends Thread {
	private SurfaceHolder mSurfaceHolder;
	public DisplayMetrics metrics = new DisplayMetrics();
	private static Bitmap mBackgroundImage;
	public static Bitmap tankImg;
	public static Bitmap cannonImg;
	public static boolean mRun = false;
	private Tank tank;
	public static Resources res;

	public GameThread(SurfaceHolder surfaceHolder, Context context, Handler handler) {
		mSurfaceHolder = surfaceHolder;
		Resources res = context.getResources();
		mBackgroundImage = BitmapFactory.decodeResource(res,R.drawable.background);
		tankImg = BitmapFactory.decodeResource(res,R.drawable.tank);
		cannonImg = BitmapFactory.decodeResource(res,R.drawable.cannon);
	}

	@Override
	public void run() {
		while (mRun) {
			Canvas c = null;
			try {
				c = mSurfaceHolder.lockCanvas(null);
				synchronized (mSurfaceHolder) {
					draw(c);
				}
			} finally {
				if (c != null) {
					mSurfaceHolder.unlockCanvasAndPost(c);
				}
			}
		}
	}
	
	public void setRunning(boolean b) {
		mRun = b;
	}
	
	private void draw(Canvas canvas) {
		canvas.drawBitmap(mBackgroundImage, 0, 0, null);
		tank.draw(canvas); 
	}

	public void createGraphics() {
		mBackgroundImage=Bitmap.createBitmap(mBackgroundImage);
		tank = new Tank();
	}
}