package pmm.antiaircraft4;

import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Matrix;

public class Ufo {
	private static final int STATUS_FLYING = 0;
	private static final int STATUS_OVER = 1;
	private static final float TIME_FLYING = 5;

	private float lowerPosition;
	private long time;
	private int status;
	private float posX;
	private float posY;
	private double iniSpeedX;
	private double iniSpeedY;
	private float posX0;
	private float drawX;
	private float drawY;
	private int angle;
	private int direction;
	private static float acceleration;

	public Ufo(){
		time = 0;
		angle = 0;
		status = STATUS_FLYING;
		direction = (Math.random()<0.5?1:-1);
		posX0 = (float) (160 + (320*-direction*Math.random()));

		lowerPosition = 480;

		acceleration = (float) (lowerPosition/Math.pow(TIME_FLYING/2,2));

		iniSpeedX = (320 / TIME_FLYING);
		iniSpeedY = (TIME_FLYING * acceleration / 2) - 1 / TIME_FLYING;

		GameThread.ufoImg = Bitmap.createBitmap(GameThread.ufoImg);
	}

	public void draw(Canvas c) {
		Matrix m = new Matrix();
		m.postTranslate(drawX, drawY);

		if (status == STATUS_FLYING) 
			c.drawBitmap(GameThread.ufoImg, m, null);
	}

	public void update(long elapsedTime) {
		double t2;
		switch (status){		
			case STATUS_FLYING:
				time+=elapsedTime;
				t2=(double)(time)/1000;
				posX = (float) (posX0 +  iniSpeedX*t2*direction);
				posY = (float) (iniSpeedY * t2 - (acceleration/2 * Math.pow(t2,2) ));
				angle = (direction>0?180:0) + (int) (Math.atan((iniSpeedY-acceleration*t2)/iniSpeedX*direction)*180/Math.PI);
				if (posY<0)
					status=STATUS_OVER;
			break;
		}

		drawX = posX - 30;
		drawY = posY - 20;
	}

	public boolean isOver() {
		return (status==STATUS_OVER);
	}

	public boolean isFlying(){
		return (status == STATUS_FLYING);
	}
}