package pmm.antiaircraft5;

import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.LinearGradient;
import android.graphics.Paint;
import android.graphics.Paint.Style;
import android.graphics.RectF;
import android.graphics.Shader;

public class Hud {
	private static final int BAR_POWER_LEFT_MARGIN = 10;
	private static final int BAR_POWER_RIGHT_MARGIN = 200;
	private static final int BAR_POWER_BOTTOM_MARGIN = 10;
	private static final int BAR_POWER_HEIGHT = 10;
	private static final int TEXT_INFO_LEFT_MARGIN = 10;
	private static final int TEXT_ANGLE_TOP_MARGIN = 25;
	private static final int TEXT_POWER_TOP_MARGIN = 50;
	private static final int TEXT_COUNTER_TOP_MARGIN = 75;
	private static final int TEXT_SIZE = 20;
	private float barPwrLeft;
	private float barPwrTop;
	private float barPwrRight;
	private float barPwrBottom;
	private int impactCounter;
	LinearGradient gradient;
	Paint paint;
	private Tank tank;

	public Hud(){
		paint = new Paint();

		barPwrLeft = BAR_POWER_LEFT_MARGIN;
		barPwrTop = 480 - BAR_POWER_BOTTOM_MARGIN - BAR_POWER_HEIGHT;
		barPwrRight = 320 - BAR_POWER_RIGHT_MARGIN;
		barPwrBottom = 480 - BAR_POWER_HEIGHT;
		impactCounter =0;
		gradient= new LinearGradient (barPwrLeft, barPwrTop, barPwrRight, barPwrTop, new int[]{Color.GREEN,Color.YELLOW, Color.RED},null, Shader.TileMode.CLAMP);
	}

	public void draw(Canvas c){
		int progress = ((int) (barPwrLeft + tank.getPower() * (barPwrRight-barPwrLeft) /100));
		paint.setAlpha(255);
		paint.setShader(gradient);
		paint.setStyle(Style.FILL);
		c.drawRoundRect(new RectF(barPwrLeft, barPwrTop, progress, barPwrBottom), 4, 4, paint);
		paint.setShader(null);
		paint.setStyle(Style.STROKE);
		paint.setColor(Color.BLACK);
		paint.setStrokeWidth(0);
		c.drawRoundRect(new RectF(barPwrLeft, barPwrTop, barPwrRight, barPwrBottom), 4, 4, paint);

		paint.setColor(Color.BLACK);
		paint.setStyle(Paint.Style.STROKE);
		paint.setStrokeWidth(0);
		paint.setAntiAlias(true);
		paint.setTextSize(TEXT_SIZE);
		int powerInfo=(tank.getPower()==0?tank.getLastBulletPower():tank.getPower());
		c.drawText("Angle: "+Math.abs((int) (tank.getAngle()*180/Math.PI))+"", TEXT_INFO_LEFT_MARGIN, TEXT_ANGLE_TOP_MARGIN, paint);
		c.drawText("Power: "+powerInfo, TEXT_INFO_LEFT_MARGIN, TEXT_POWER_TOP_MARGIN, paint);
		c.drawText("Impacts: "+impactCounter, TEXT_INFO_LEFT_MARGIN, TEXT_COUNTER_TOP_MARGIN, paint);
	}

	public void register(Tank tank) {
		this.tank = tank;
	}
	
	public void addImpact() {
		impactCounter++;
	}
}